
Ruby - Bug #14898

test/lib/test/unit/parallel.rb: TestSocket#test_timestamp stuck sometimes

07/06/2018 08:31 AM - ko1 (Koichi Sasada)

Status: Closed   

Priority: Normal   

Assignee:    

Target version: 2.6   

ruby -v: 2.6 Backport: 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:

UNKNOWN

Description

With parallel tests (make test-all TESTS=-j4 with 4 parallelism) stuck sometimes.

http://ci.rvm.jp/results/trunk-test@ruby-sky3/1087178

We can see this stuck very old revisions but not sure how to solve...

Anyone help us?

Associated revisions

Revision eb78bedab73136cf78df1db6fb77b130ca39255f - 07/07/2018 05:34 AM - Eric Wong 

test/socket/test_socket.rb (test_timestamp): retry send

I theorize there can be UDP packet loss even over loopback if

the kernel is under memory pressure.  Retry sending periodically

until recvmsg succeeds.

i[ruby-core:87842] [Bug #14898]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63872 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision eb78bedab73136cf78df1db6fb77b130ca39255f - 07/07/2018 05:34 AM - Eric Wong 

test/socket/test_socket.rb (test_timestamp): retry send

I theorize there can be UDP packet loss even over loopback if

the kernel is under memory pressure.  Retry sending periodically

until recvmsg succeeds.

i[ruby-core:87842] [Bug #14898]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63872 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision eb78beda - 07/07/2018 05:34 AM - Eric Wong 

test/socket/test_socket.rb (test_timestamp): retry send

I theorize there can be UDP packet loss even over loopback if

the kernel is under memory pressure.  Retry sending periodically

until recvmsg succeeds.

i[ruby-core:87842] [Bug #14898]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63872 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 12f11714c2c3fd1cfc98d30fdbb777260132b818 - 08/02/2018 06:09 AM - Eric Wong 

test/socket/test_socket.rb (test_timestampns): retry send

It looks like we need to retry test_timestampns in addition

to test_timestamp; so share some code while we're at it.

cf. http://ci.rvm.jp/results/trunk-test@frontier/1153126

[ruby-core:88104] [Bug #14898]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64157 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 12f11714c2c3fd1cfc98d30fdbb777260132b818 - 08/02/2018 06:09 AM - Eric Wong 

test/socket/test_socket.rb (test_timestampns): retry send

It looks like we need to retry test_timestampns in addition

to test_timestamp; so share some code while we're at it.

cf. http://ci.rvm.jp/results/trunk-test@frontier/1153126

[ruby-core:88104] [Bug #14898]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64157 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 12f11714 - 08/02/2018 06:09 AM - Eric Wong 

test/socket/test_socket.rb (test_timestampns): retry send

It looks like we need to retry test_timestampns in addition

to test_timestamp; so share some code while we're at it.

cf. http://ci.rvm.jp/results/trunk-test@frontier/1153126

[ruby-core:88104] [Bug #14898]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64157 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ce48b55805873ad3913be832e919e3ebe8b8f7a3 - 08/20/2018 08:45 PM - Eric Wong 

test/socket/test_socket.rb (timestamp_retry_rw): IO.select before recvmsg

CI failures are still happening from these tests, but try

to break out of it earlier instead of holding up the job.

[Bug #14898]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64484 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ce48b55805873ad3913be832e919e3ebe8b8f7a3 - 08/20/2018 08:45 PM - Eric Wong 

test/socket/test_socket.rb (timestamp_retry_rw): IO.select before recvmsg

CI failures are still happening from these tests, but try

to break out of it earlier instead of holding up the job.

[Bug #14898]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64484 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ce48b558 - 08/20/2018 08:45 PM - Eric Wong 

test/socket/test_socket.rb (timestamp_retry_rw): IO.select before recvmsg

CI failures are still happening from these tests, but try

to break out of it earlier instead of holding up the job.

[Bug #14898]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64484 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 07/06/2018 09:52 AM - normalperson (Eric Wong)

ko1@atdot.net wrote:

With parallel tests (make test-all TESTS=-j4 with 4 parallelism) stuck sometimes.

http://ci.rvm.jp/results/trunk-test@ruby-sky3/1087178

We can see this stuck very old revisions but not sure how to solve...

 I've never seen it stuck myself.

Is UDP over loopback supposed to be reliable?

I would not expect it to be (but am not sure), I think it's

possible the kernel could drop packets if under memory pressure.
#2 - 07/07/2018 03:42 AM - ko1 (Koichi Sasada)

On 2018/07/06 18:47, Eric Wong wrote:

I've never seen it stuck myself.

 Only a few times per thousands trial. I also never seen in manual trial.

Is UDP over loopback supposed to be reliable?

 Maybe yes because other tests passed.

I would not expect it to be (but am not sure), I think it's

possible the kernel could drop packets if under memory pressure.

 mmm. can we rewrite tests with this concern?

--

// SASADA Koichi at atdot dot net

#3 - 07/07/2018 05:36 AM - normalperson (Eric Wong)

- Status changed from Open to Closed

Applied in changeset trunk|r63872.

test/socket/test_socket.rb (test_timestamp): retry send

I theorize there can be UDP packet loss even over loopback if

the kernel is under memory pressure.  Retry sending periodically

until recvmsg succeeds.

i[ruby-core:87842] [Bug #14898]

#4 - 07/07/2018 05:42 AM - normalperson (Eric Wong)

Koichi Sasada ko1@atdot.net wrote:

On 2018/07/06 18:47, Eric Wong wrote:

I would not expect it to be (but am not sure), I think it's

possible the kernel could drop packets if under memory pressure.

 mmm. can we rewrite tests with this concern?

 Maybe r63872 can help by retrying send.

#5 - 07/07/2018 05:52 AM - ko1 (Koichi Sasada)

On 2018/07/07 14:36, Eric Wong wrote:

Maybe r63872 can help by retrying send.

 Great! Thank you.

--

// SASADA Koichi at atdot dot net

#6 - 07/25/2018 10:07 AM - ko1 (Koichi Sasada)

http://ci.rvm.jp/results/trunk-test@frontier/1153126

doesn't fixed yet :(

#7 - 07/25/2018 10:07 AM - ko1 (Koichi Sasada)

- Status changed from Closed to Open
#8 - 08/02/2018 06:10 AM - normalperson (Eric Wong)

- Status changed from Open to Closed

Applied in changeset trunk|r64157.

test/socket/test_socket.rb (test_timestampns): retry send

It looks like we need to retry test_timestampns in addition

to test_timestamp; so share some code while we're at it.

cf. http://ci.rvm.jp/results/trunk-test@frontier/1153126

[ruby-core:88104] [Bug #14898]

#9 - 08/02/2018 06:13 AM - normalperson (Eric Wong)

ko1@atdot.net wrote:

http://ci.rvm.jp/results/trunk-test@frontier/1153126

 Oh, different test, that is test_timestampns getting stuck.

Trying r64157:

test/socket/test_socket.rb (test_timestampns): retry send

It looks like we need to retry test_timestampns in addition

to test_timestamp; so share some code while we're at it.

#10 - 08/02/2018 09:32 PM - normalperson (Eric Wong)

http://ci.rvm.jp/results/trunk_clang_38@silicon-docker/1185552

:<

ko1@atdot.net wrote:

http://ci.rvm.jp/results/trunk-test@frontier/1153126

 

ko1: is frontier also on Docker?  I seem to remember hearing of

some UDP problems in containers several years ago, but maybe it

was only UDP multicast...  This was years ago, and I never tried

containers myself.

#11 - 08/08/2018 06:31 AM - ko1 (Koichi Sasada)

Oh, different test, that is test_timestampns getting stuck.

 sorry.

ko1: is frontier also on Docker?

 No. It raw Linux machine.

#12 - 08/20/2018 06:12 AM - normalperson (Eric Wong)

ko1@atdot.net wrote:

Bug #14898: test/lib/test/unit/parallel.rb: TestSocket#test_timestamp stuck sometimes

https://bugs.ruby-lang.org/issues/14898#change-73373

 Still not solved.  This might be a similar issue to r64478 with

too many pipes...
